
AC_DEFUN(LAC_GRAM_ARGS,
[

AC_ARG_WITH(gram-job-manager,
	[  --with-gram-job-manager       GRAM job manager: condor, easymcs, lsf, loadleveler, poe, or fork [fork]],
	[if test "$withval" = "yes" ; then
	     globus_cv_gram_job_manager="fork"
         else
             globus_cv_gram_job_manager="$withval"
         fi
        ],
	[globus_cv_gram_job_manager="fork"])


AC_ARG_WITH(gram-gatekeeper,
	[  --with-gram-gatekeeper        Install the gram gatekeeper [yes]],
	[ globus_cv_gram_gatekeeper="$withval"],
	[ globus_cv_gram_gatekeeper="yes"])



AC_ARG_WITH(gram-port,
       [  --with-gram-port              port number of the gatekeeper [754]],
       [lac_gram_port="$withval"],
       [lac_gram_port="754"])


AC_ARG_ENABLE(gram-test,
        [  --disable-gram-test           don't configure GRAM test],
        [lac_enable_gram_test="$enableval"],
        [lac_enable_gram_test="yes"])

])

AC_DEFUN(LAC_GRAM_MYJOB,
[
    if test "$lac_mpl" = "yes" ; then
        GRAM_MYJOB_SHARED_PROTO_OBJS="globus_gram_myjob_mpl.\$(OFILE)"
    elif test "$lac_mpi" = "yes" ; then
        GRAM_MYJOB_SHARED_PROTO_OBJS="globus_gram_myjob_mpi.\$(OFILE)"
    elif test "$lac_inx" = "yes" ; then
        GRAM_MYJOB_SHARED_PROTO_OBJS="globus_gram_myjob_inx.\$(OFILE)"
    else
        GRAM_MYJOB_SHARED_PROTO_OBJS="globus_gram_myjob_duct.\$(OFILE)"
    fi
    AC_SUBST(GRAM_MYJOB_SHARED_PROTO_OBJS)
])

AC_DEFUN(LAC_GRAM,
[
    LAC_GRAM_ARGS

    case "$globus_cv_gram_job_manager" in
        condor )
            GRAM_JM_METHOD=globus_i_gram_jm_shell
            GRAM_JM_SHELL_TYPE=condor
            GRAM_JM_SHELL_DEFINE=-DGRAMI_CONDOR_MANAGER
        ;;
        easymcs )
            GRAM_JM_METHOD=globus_i_gram_jm_shell
            GRAM_JM_SHELL_TYPE=easymcs
            GRAM_JM_SHELL_DEFINE=-DGRAMI_EASYMCS_MANAGER
        ;;
        loadleveler )
            GRAM_JM_METHOD=globus_i_gram_jm_shell
            GRAM_JM_SHELL_TYPE=loadleveler
            GRAM_JM_SHELL_DEFINE=-DGRAMI_LOADLEVELER_MANAGER
        ;;
        t3e_nqe )
            GRAM_JM_METHOD=globus_i_gram_jm_shell
            GRAM_JM_SHELL_TYPE=t3e_nqe
            GRAM_JM_SHELL_DEFINE=-DGRAMI_T3E_NQE_MANAGER
        ;;
        lsf )
            GRAM_JM_METHOD=globus_i_gram_jm_shell
            GRAM_JM_SHELL_TYPE=lsf
            GRAM_JM_SHELL_DEFINE=-DGRAMI_LSF_MANAGER
        ;;
        pbs )
            GRAM_JM_METHOD=globus_i_gram_jm_shell
            GRAM_JM_SHELL_TYPE=pbs
            GRAM_JM_SHELL_DEFINE=-DGRAMI_PBS_MANAGER
        ;;
	poe )
	    GRAM_JM_METHOD=globus_i_gram_jm_fork
	    GRAM_JM_SHELL_TYPE=none
	    GRAM_JM_SHELL_DEFINE=-DGRAMI_POE_MANAGER
	;;
        fork )
            GRAM_JM_METHOD=globus_i_gram_jm_fork
            GRAM_JM_SHELL_TYPE=none
            GRAM_JM_SHELL_DEFINE=
        ;;
        fake )
            GRAM_JM_METHOD=globus_i_gram_jm_fake
            GRAM_JM_SHELL_TYPE=none
            GRAM_JM_SHELL_DEFINE=
        ;;
	no )
	;;
        * )
            AC_MSG_ERROR([Invalid --with-gram-job-manager value: $globus_cv_gram_job_manager])
        ;;
    esac
    
    GRAM_JM_TYPE=$globus_cv_gram_job_manager

    AC_SUBST(GRAM_JM_TYPE)
    AC_SUBST(GRAM_JM_METHOD)
    AC_SUBST(GRAM_JM_SHELL_TYPE)
    AC_SUBST(GRAM_JM_SHELL_DEFINE)

    dnl Assign all of the GRAM_ERROR values
    GLOBUS_GRAM_CLIENT_ERROR_PARAMETER_NOT_SUPPORTED=1
    GLOBUS_GRAM_CLIENT_ERROR_INVALID_REQUEST=2
    GLOBUS_GRAM_CLIENT_ERROR_NO_RESOURCES=3
    GLOBUS_GRAM_CLIENT_ERROR_BAD_DIRECTORY=4
    GLOBUS_GRAM_CLIENT_ERROR_EXECUTABLE_NOT_FOUND=5
    GLOBUS_GRAM_CLIENT_ERROR_INSUFFICIENT_FUNDS=6
    GLOBUS_GRAM_CLIENT_ERROR_AUTHORIZATION=7
    GLOBUS_GRAM_CLIENT_ERROR_USER_CANCELLED=8
    GLOBUS_GRAM_CLIENT_ERROR_SYSTEM_CANCELLED=9
    GLOBUS_GRAM_CLIENT_ERROR_PROTOCOL_FAILED=10
    GLOBUS_GRAM_CLIENT_ERROR_STDIN_NOT_FOUND=11
    GLOBUS_GRAM_CLIENT_ERROR_CONNECTION_FAILED=12
    GLOBUS_GRAM_CLIENT_ERROR_INVALID_MAXTIME=13
    GLOBUS_GRAM_CLIENT_ERROR_INVALID_COUNT=14
    GLOBUS_GRAM_CLIENT_ERROR_NULL_SPECIFICATION_TREE=15
    GLOBUS_GRAM_CLIENT_ERROR_JM_FAILED_ALLOW_ATTACH=16
    GLOBUS_GRAM_CLIENT_ERROR_JOB_EXECUTION_FAILED=17
    GLOBUS_GRAM_CLIENT_ERROR_INVALID_PARADYN=18
    GLOBUS_GRAM_CLIENT_ERROR_INVALID_JOBTYPE=19
    GLOBUS_GRAM_CLIENT_ERROR_INVALID_GRAM_MYJOB=20
    GLOBUS_GRAM_CLIENT_ERROR_BAD_SCRIPT_ARG_FILE=21
    GLOBUS_GRAM_CLIENT_ERROR_ARG_FILE_CREATION_FAILED=22
    GLOBUS_GRAM_CLIENT_ERROR_INVALID_JOBSTATE=23
    GLOBUS_GRAM_CLIENT_ERROR_INVALID_SCRIPT_REPLY=24
    GLOBUS_GRAM_CLIENT_ERROR_INVALID_SCRIPT_STATUS=25
    GLOBUS_GRAM_CLIENT_ERROR_JOBTYPE_NOT_SUPPORTED=26
    GLOBUS_GRAM_CLIENT_ERROR_UNIMPLEMENTED=27
    GLOBUS_GRAM_CLIENT_ERROR_TEMP_SCRIPT_FILE_FAILED=28
    GLOBUS_GRAM_CLIENT_ERROR_USER_PROXY_NOT_FOUND=29
    GLOBUS_GRAM_CLIENT_ERROR_OPENING_USER_PROXY=30
    GLOBUS_GRAM_CLIENT_ERROR_JOB_CANCEL_FAILED=31
    GLOBUS_GRAM_CLIENT_ERROR_MALLOC_FAILED=32
    GLOBUS_GRAM_CLIENT_ERROR_DUCT_INIT_FAILED=33
    GLOBUS_GRAM_CLIENT_ERROR_DUCT_LSP_FAILED=34
    GLOBUS_GRAM_CLIENT_ERROR_INVALID_HOST_COUNT=35
    GLOBUS_GRAM_CLIENT_ERROR_UNSUPPORTED_PARAMETER=36
    GLOBUS_GRAM_CLIENT_ERROR_INVALID_QUEUE=37
    GLOBUS_GRAM_CLIENT_ERROR_INVALID_PROJECT=38
    GLOBUS_GRAM_CLIENT_ERROR_RSL_EVALUATION_FAILED=39
    GLOBUS_GRAM_CLIENT_ERROR_BAD_RSL_ENVIRONMENT=40
    GLOBUS_GRAM_CLIENT_ERROR_DRYRUN=41
    GLOBUS_GRAM_CLIENT_ERROR_ZERO_LENGTH_RSL=42
    GLOBUS_GRAM_CLIENT_ERROR_STAGING_EXECUTABLE=43
    GLOBUS_GRAM_CLIENT_ERROR_STAGING_STDIN=44
    GLOBUS_GRAM_CLIENT_ERROR_INVALID_JOB_MANAGER_TYPE=45
    GLOBUS_GRAM_CLIENT_ERROR_BAD_ARGUMENTS=46
    GLOBUS_GRAM_CLIENT_ERROR_GATEKEEPER_MISCONFIGURED=47
    GLOBUS_GRAM_CLIENT_ERROR_BAD_RSL=48
    GLOBUS_GRAM_CLIENT_ERROR_VERSION_MISMATCH=49
    GLOBUS_GRAM_CLIENT_ERROR_RSL_ARGUMENTS=50
    GLOBUS_GRAM_CLIENT_ERROR_RSL_COUNT=51
    GLOBUS_GRAM_CLIENT_ERROR_RSL_DIRECTORY=52
    GLOBUS_GRAM_CLIENT_ERROR_RSL_DRYRUN=53
    GLOBUS_GRAM_CLIENT_ERROR_RSL_ENVIRONMENT=54
    GLOBUS_GRAM_CLIENT_ERROR_RSL_EXECUTABLE=55
    GLOBUS_GRAM_CLIENT_ERROR_RSL_HOST_COUNT=56
    GLOBUS_GRAM_CLIENT_ERROR_RSL_JOBTYPE=57
    GLOBUS_GRAM_CLIENT_ERROR_RSL_MAXTIME=58
    GLOBUS_GRAM_CLIENT_ERROR_RSL_MYJOB=59
    GLOBUS_GRAM_CLIENT_ERROR_RSL_PARADYN=60
    GLOBUS_GRAM_CLIENT_ERROR_RSL_PROJECT=61
    GLOBUS_GRAM_CLIENT_ERROR_RSL_QUEUE=62
    GLOBUS_GRAM_CLIENT_ERROR_RSL_STDERR=63
    GLOBUS_GRAM_CLIENT_ERROR_RSL_STDIN=64
    GLOBUS_GRAM_CLIENT_ERROR_RSL_STDOUT=65
    GLOBUS_GRAM_CLIENT_ERROR_OPENING_JOBMANAGER_SCRIPT=66
    GLOBUS_GRAM_CLIENT_ERROR_CREATING_PIPE=67
    GLOBUS_GRAM_CLIENT_ERROR_FCNTL_FAILED=68
    GLOBUS_GRAM_CLIENT_ERROR_STDOUT_FILENAME_FAILED=69
    GLOBUS_GRAM_CLIENT_ERROR_STDERR_FILENAME_FAILED=70
    GLOBUS_GRAM_CLIENT_ERROR_FORKING_EXECUTABLE=71
    GLOBUS_GRAM_CLIENT_ERROR_EXECUTABLE_PERMISSIONS=72
    GLOBUS_GRAM_CLIENT_ERROR_OPENING_STDOUT=73
    GLOBUS_GRAM_CLIENT_ERROR_OPENING_STDERR=74
    GLOBUS_GRAM_CLIENT_ERROR_OPENING_CACHE_USER_PROXY=75
    GLOBUS_GRAM_CLIENT_ERROR_OPENING_CACHE=76
     
    dnl Add new GRAM_ERROR codes here, and set GLOBUS_GRAM_CLIENT_ERROR_LAST
    dnl to be one higher than the last error code
    GLOBUS_GRAM_CLIENT_ERROR_LAST=77

    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_PARAMETER_NOT_SUPPORTED)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_INVALID_REQUEST)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_NO_RESOURCES)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_BAD_DIRECTORY)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_EXECUTABLE_NOT_FOUND)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_INSUFFICIENT_FUNDS)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_AUTHORIZATION)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_USER_CANCELLED)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_SYSTEM_CANCELLED)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_PROTOCOL_FAILED)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_STDIN_NOT_FOUND)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_CONNECTION_FAILED)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_INVALID_MAXTIME)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_INVALID_COUNT)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_NULL_SPECIFICATION_TREE)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_JM_FAILED_ALLOW_ATTACH)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_JOB_EXECUTION_FAILED)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_INVALID_PARADYN)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_INVALID_JOBTYPE)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_INVALID_GRAM_MYJOB)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_BAD_SCRIPT_ARG_FILE)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_ARG_FILE_CREATION_FAILED)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_INVALID_JOBSTATE)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_INVALID_SCRIPT_REPLY)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_INVALID_SCRIPT_STATUS)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_JOBTYPE_NOT_SUPPORTED)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_UNIMPLEMENTED)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_TEMP_SCRIPT_FILE_FAILED)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_USER_PROXY_NOT_FOUND)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_OPENING_USER_PROXY)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_JOB_CANCEL_FAILED)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_MALLOC_FAILED)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_DUCT_INIT_FAILED)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_DUCT_LSP_FAILED)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_INVALID_HOST_COUNT)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_UNSUPPORTED_PARAMETER)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_INVALID_QUEUE)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_INVALID_PROJECT)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_RSL_EVALUATION_FAILED)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_BAD_RSL_ENVIRONMENT)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_DRYRUN)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_ZERO_LENGTH_RSL)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_STAGING_EXECUTABLE)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_STAGING_STDIN)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_INVALID_JOB_MANAGER_TYPE)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_BAD_ARGUMENTS)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_GATEKEEPER_MISCONFIGURED)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_BAD_RSL)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_VERSION_MISMATCH)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_RSL_ARGUMENTS)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_RSL_COUNT)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_RSL_DIRECTORY)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_RSL_DRYRUN)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_RSL_ENVIRONMENT)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_RSL_EXECUTABLE)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_RSL_HOST_COUNT)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_RSL_JOBTYPE)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_RSL_MAXTIME)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_RSL_MYJOB)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_RSL_PARADYN)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_RSL_PROJECT)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_RSL_QUEUE)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_RSL_STDERR)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_RSL_STDIN)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_RSL_STDOUT)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_OPENING_JOBMANAGER_SCRIPT)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_CREATING_PIPE)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_FCNTL_FAILED)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_STDOUT_FILENAME_FAILED)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_STDERR_FILENAME_FAILED)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_FORKING_EXECUTABLE)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_EXECUTABLE_PERMISSIONS)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_OPENING_STDOUT)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_OPENING_STDERR)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_OPENING_CACHE_USER_PROXY)
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_OPENING_CACHE)

    dnl Add new GRAM_ERROR codes here
    AC_SUBST(GLOBUS_GRAM_CLIENT_ERROR_LAST)

    dnl Assign all of the GRAM_STATE values
    GLOBUS_GRAM_CLIENT_JOB_STATE_PENDING=1
    GLOBUS_GRAM_CLIENT_JOB_STATE_ACTIVE=2
    GLOBUS_GRAM_CLIENT_JOB_STATE_FAILED=4
    GLOBUS_GRAM_CLIENT_JOB_STATE_DONE=8
    GLOBUS_GRAM_CLIENT_JOB_STATE_SUSPENDED=16
    GLOBUS_GRAM_CLIENT_JOB_STATE_ALL=0xFFFFF

    AC_SUBST(GLOBUS_GRAM_CLIENT_JOB_STATE_PENDING)
    AC_SUBST(GLOBUS_GRAM_CLIENT_JOB_STATE_ACTIVE)
    AC_SUBST(GLOBUS_GRAM_CLIENT_JOB_STATE_FAILED)
    AC_SUBST(GLOBUS_GRAM_CLIENT_JOB_STATE_DONE)
    AC_SUBST(GLOBUS_GRAM_CLIENT_JOB_STATE_SUSPENDED)
    AC_SUBST(GLOBUS_GRAM_CLIENT_JOB_STATE_ALL)
])


AC_DEFUN(LAC_LSF_DIR,
[

  if test -d $1 ; then
    LSF_DIRS="$LSF_DIRS $2 $1"
  fi
])
