#include "globus_common.h"
#include <stdio.h>

globus_bool_t
poll_func1(
    globus_bool_t			blocking_allowed)
{
    static int				cnt = 0;
    
    printf("poll_func1(): blocking=%d, cnt=%d\n", blocking_allowed, cnt);

    cnt++;

    if (cnt % 5 == 0)
    {
	return GLOBUS_TRUE;
    }
    else
    {
	return GLOBUS_FALSE;
    }
}

globus_bool_t
poll_func2(
    globus_bool_t			blocking_allowed)
{
    static int				cnt = 0;
    
    printf("poll_func2(): blocking=%d, cnt=%d\n", blocking_allowed, cnt);

    cnt++;

    if (cnt % 7 == 0)
    {
	return GLOBUS_TRUE;
    }
    else
    {
	return GLOBUS_FALSE;
    }
}

int
main(
    int					argc,
    char *				argv[])
{
    int					rc;
    
    rc = globus_module_activate(GLOBUS_COMMON_MODULE);
    fprintf(stderr, "activating globus_common\n");
    fprintf(stderr, "rc=%d\n", rc);
    globus_i_module_dump(stderr);

    globus_poll_add(poll_func1, 1);
    globus_poll_add(poll_func2, 1);

    printf("globus_poll_nonblocking()\n");
    globus_poll_nonblocking();
    printf("globus_poll()\n");
    globus_poll();
    printf("globus_poll_blocking()\n");
    globus_poll_blocking();
    printf("globus_poll_blocking()\n");
    globus_poll_blocking();
    
    
    fprintf(stderr, "deactivating globus_common\n");
    rc = globus_module_deactivate(GLOBUS_COMMON_MODULE);
    fprintf(stderr, "rc=%d\n", rc);
    globus_i_module_dump(stderr);
    
    return(0);
}
