#include "globus_common.h"
#include <stdio.h>

char *test_urls[] = { "ftp://ftp.mcs.anl.gov/pub/foobar", /* good */
		      "x-gass://host:3141/foo",           /* good */
		      "x-gass://host:3141/foo?bar&baz",   /* good */
		      "http://www.globus.org",            /* good */
		      "http://www.globus.org/~bester",    /* good */
		      "file:///bin/sh",                   /* good */
		      "ftp://bester:password@ftp.mcs.anl.gov/pub/foo", /* good */
		      "x-nexus://pitcairn-9.mcs.anl.gov:8713", /* good */
		      "ldap://mds.globus.org/o=Globus,c=US?dn?SUBTREE?hn=pitcairn.mcs.anl.gov-fork", /* good */
		      "ldap://mds.globus.org/ou=MCS,%20o=Argonne%20National%20Laboratory,%20o=Globus,%20c=US?dn?SUBTREE?hn=pitcairn.mcs.anl.gov-fork", /* good */
		      "x123://foo_this",                  /* good */
		      "ldap://mds.globus.org/o=Globus,c=US?%%?SUBTREE?hn=pitcairn.mcs.anl.gov-fork", /* bad */
		      "ldap://mds.globus.org/ou=MCS,o=Argonne National Laboratory, o=Globus, c=US?dn?hn=pitcairn.mcs.anl.gov-fork", /* bad */
		      "x-gass://host:123/\\",             /* bad */
		      "ftp://user:\\@host/foo",           /* bad */
		      "ftp://host:asdf/foo",              /* bad */
		      "x-nexus://bad\\host\\:123",        /* bad */
		      "x-nexus://\\\\",                   /* bad */
		      "ftp://bester:huh%%@ftp.mcs.anl.gov/pub/foo", /* bad */
		      "ftp://foo%%@host/foo",                /* bad */
		      "ftp://huh%%@ftp.mcs.anl.gov/pub/foo", /* bad */
		      "file:/",                           /* bad */
		      "://\\@host/foo",                   /* bad */
		      "X123://foo_this",                  /* bad */
		      GLOBUS_NULL};

int main()
{
    globus_url_t url;
    char **the_url = &test_urls[0];
    
    globus_module_activate(GLOBUS_COMMON_MODULE);
    while(*the_url)
    {
	printf("\"%s\" %i\n", *the_url, globus_url_parse(*the_url, &url));
	fflush(stdout);
	globus_url_destroy(&url);
	the_url++;
    }
    printf("\"%s\" %i\n", *(the_url-1), globus_url_parse(*(the_url-1), GLOBUS_NULL));
    printf("\"%s\" %i\n", "<NULL>", globus_url_parse(*the_url, &url));
    globus_url_destroy(&url);
    globus_module_deactivate(GLOBUS_COMMON_MODULE);
    return 0;
}
