/******************************************************************************
Description:

  Top level CIF class definition

CVS Information:

  $Source: /home/dsl/Master/cif/CIF-Comm-C++-Current/library/CIF_Comm.C,v $
  $Date: 1998/09/28 20:16:21 $
  $Revision: 1.5 $
  $State: Exp $
  $Author: toonen $
******************************************************************************/

#include "CIF_Comm.H"
#include "globus_nexus.h"
#include "globus_common.h"

globus_module_descriptor_t
CIF_Comm::l_module_descriptor =
{
    "CIF_Comm",
    CIF_Comm::l_activate,
    CIF_Comm::l_deactivate,
    GLOBUS_NULL
};

CIF_Comm_Status
CIF_Comm::status = CIF_Comm_Status::SUCCESS; 


CIF_Bool
CIF_Comm::activate()
{
    int					rc;
    
    rc = globus_module_activate(&l_module_descriptor);
    if (rc == GLOBUS_SUCCESS)
    {
	CIF_Comm::status = CIF_Comm_Status::SUCCESS;
	return true;
    }
    else
    {
	CIF_Comm::status = CIF_Comm_Status::FAILURE;
	return false;
    }
}


void
CIF_Comm::poll()
{
    CIF_Toolkit::poll();
}


CIF_Bool
CIF_Comm::deactivate()
{
    int					rc;
    
    rc = globus_module_deactivate(&l_module_descriptor);
    if (rc == GLOBUS_SUCCESS)
    {
	CIF_Comm::status = CIF_Comm_Status::SUCCESS;
	return true;
    }
    else
    {
	CIF_Comm::status = CIF_Comm_Status::FAILURE;
	return false;
    }
}


int
CIF_Comm::l_activate()
{
    if (CIF_Toolkit::activate() != true)
    {
	goto fn_abort;
    }

    if (globus_module_activate(GLOBUS_NEXUS_MODULE) != GLOBUS_SUCCESS)
    {
	goto fn_abort;	
    }

    if (globus_module_activate(GLOBUS_COMMON_MODULE) != GLOBUS_SUCCESS)
    {
	globus_module_deactivate(GLOBUS_NEXUS_MODULE);
	goto fn_abort;	
    }

    globus_nexus_enable_fault_tolerance(l_handle_Fault, GLOBUS_NULL);
    
    return true;

  fn_abort:
    return false;
}

int
CIF_Comm::l_deactivate()
{
    int						rc;

    rc = GLOBUS_SUCCESS;
    
    if (globus_module_deactivate(GLOBUS_NEXUS_MODULE) != GLOBUS_SUCCESS)
    {
	rc = GLOBUS_FAILURE;
    }
    
    if (globus_module_deactivate(GLOBUS_COMMON_MODULE) != GLOBUS_SUCCESS)
    {
	rc = GLOBUS_FAILURE;
    }

    if (CIF_Toolkit::deactivate() != true)
    {
	rc = GLOBUS_FAILURE;
    }

    return rc;
}

int
CIF_Comm::l_handle_Fault(
    void *					user_arg,
    int						fault_code)
{
    fprintf(stderr,
	    "\nCIF_Comm WARNING: "
	    "Ignoring exception %d received from Nexus.\n\n",
	    fault_code);

    return 0;
}
