/******************************************************************************
CIF_Comm_Message.C

Description:

  Message buffer class

CVS Information:

  $Source: /home/dsl/Master/cif/CIF-Comm-C++-Current/library/CIF_Comm_Message.C,v $
  $Date: 1998/09/28 10:43:32 $
  $Revision: 1.4 $
  $State: Exp $
  $Author: toonen $
******************************************************************************/

/******************************************************************************
			     Include header files
******************************************************************************/
#include "CIF_Comm.H"


/******************************************************************************
			Define methods for CIF_Comm_Message
******************************************************************************/

/* XXX - need to set CIF_Comm::status and check state */

/*
 * CIF_Comm_Message::CIF_Comm_Message()
 */
CIF_Comm_Message::CIF_Comm_Message()
{
    l_object_state = OBJECT_STATE_INACTIVE;
    CIF_Comm::status = CIF_Comm_Status::SUCCESS;
}


/*
 * CIF_Comm_Message::activate()
 */
CIF_Bool
CIF_Comm_Message::activate(
    ARG_IN const
    CIF_Comm_Message_Info &		info)
{
    if (l_object_state == OBJECT_STATE_ACTIVE)
    {
	deactivate();
    }

    l_info = info;
    l_data = new CIF_Byte [info.size];

    CIF_Comm::status = CIF_Comm_Status::SUCCESS;
    return true;
}	
/* CIF_Comm_Message::activate() */

/*
 * CIF_Comm_Message::get_Data()
 */
CIF_Byte *
CIF_Comm_Message::get_Data()
{
    CIF_Comm::status = CIF_Comm_Status::SUCCESS;
    return(l_data);
}
/* CIF_Comm_Message::get_Data() */

/*
 * CIF_Comm_Message::get_Info()
 */
CIF_Comm_Message_Info
CIF_Comm_Message::get_Info()
{
    CIF_Comm::status = CIF_Comm_Status::SUCCESS;
    return(l_info);
}
/* CIF_Comm_Message::get_Info() */

/*
 * CIF_Comm_Message::deactivate()
 */
CIF_Bool
CIF_Comm_Message::deactivate()
{
    if (l_object_state == OBJECT_STATE_ACTIVE)
    {
	delete [] l_data;
    }

    l_object_state = OBJECT_STATE_INACTIVE;

    CIF_Comm::status = CIF_Comm_Status::SUCCESS;
    return true;
}	
/* CIF_Comm_Message::deactivate() */

/*
 * CIF_Comm_Message::~CIF_Comm_Message()
 */
CIF_Comm_Message::~CIF_Comm_Message()
{
    CIF_Comm_Status				status;

    status = CIF_Comm::status;
    {
	if (l_object_state == OBJECT_STATE_ACTIVE)
	{
	    deactivate();
	}
    
	l_object_state = OBJECT_STATE_DELETED;
    }
    CIF_Comm::status = status;
}


