/******************************************************************************
CIF_Toolkit_Cond.H

Description:

  A condition variable class used to wait for and signal condition changes
  
CVS Information:

  $Source: /home/dsl/Master/cif/CIF-Comm-C++-Current/library/CIF_Toolkit_Cond.C,v $
  $Date: 1998/09/28 10:43:35 $
  $Revision: 1.3 $
  $State: Exp $
  $Author: toonen $
******************************************************************************/

/******************************************************************************
			     Include header files
******************************************************************************/
#include "CIF_Toolkit.H"


/******************************************************************************
			 Define CIF_Toolkit_Cond class
******************************************************************************/

CIF_Toolkit_Cond::CIF_Toolkit_Cond()
{
    globus_cond_init(&l_cond, (globus_condattr_t *) GLOBUS_NULL);
}

    
CIF_Toolkit_Cond::~CIF_Toolkit_Cond()
{
    globus_cond_destroy(&l_cond);
}


void
CIF_Toolkit_Cond::wait(
    CIF_Toolkit_Mutex &				mutex,
    const CIF_Toolkit_Timeout &			timeout)
{
    if (timeout == CIF_Toolkit_Timeout::INFINITY)
    {
	globus_cond_wait(&l_cond, &mutex.l_mutex);
    }
    else
    {
	/*
	 * TODO: This is really going to chew on the CPU, but it's the best we
	 * can do until globus_cond_timedwait() or timed events have been added
	 * to Globus.  This code should be updated once one of those have been
	 * added.
	 */
	mutex.unlock();
	CIF_Toolkit::poll();
	globus_thread_yield();
	mutex.lock();
    }
}


void
CIF_Toolkit_Cond::signal()
{
    globus_cond_signal(&l_cond);
}

void
CIF_Toolkit_Cond::broadcast()
{
    globus_cond_broadcast(&l_cond);
}

